//
//  WinController.m
//  BioMorph
//
//  Created by Carson Baker on 5/11/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "MyController.h"
#import "BioView.h"

#import "math.h"

@implementation MyController

- (void)clearImageRep {
    unsigned char 	*pixels;
    int				i;
    
    pixels = [_imageRep bitmapData];

    int length = [_imageRep pixelsHigh] * [_imageRep pixelsWide];
    
    for (i=0; i<length; i++) {
        pixels[3*i+0] = 255;
        pixels[3*i+1] = 255;
        pixels[3*i+2] = 255;
    }
}

- (void) generateImageRep {

	int j, i, k;
	
	
		unsigned char 	*pixels;

		pixels = [_imageRep bitmapData];
		
		float x = 0;
		float y = 0;
		
		float aspectRatio = 5.0/10.0;
		
		float xmax = 2.5;
		float ymax = xmax * aspectRatio;
		float xmin = -xmax;
		float ymin = -ymax;
		
		_animZ += 0.001;

	
	for(j = 0; j < [_imageRep pixelsHigh]; j++) {
		for(k = 0; k < [_imageRep pixelsWide]; k++) {
		
			x = xmin + (xmax - xmin) * k / [_imageRep pixelsWide];
			y = -ymin - (ymax - ymin) * j / [_imageRep pixelsHigh];
			
			//float newx = pow(x,3) - (3 * x * pow(y,2)) + 0.5;
			//float newy = (3 * pow(x,2) * y) - pow(y,3);
			
			float distance;
			
			
			for(i = 0; i < 25; i++) {
			
				//float newx = x * (x * x - 3 * y * y) + 0.5;
				//float newy = y * (3 * x * x - y * y) + 0;
				
				float newx = x * x - y * y + 0.5 * _animZ;
				float newy = 2 * x * y + 0.7 + _animZ;
				
				x = newx;
				y = newy;
			
				if(abs(x) > 10 || (abs(y) > 10) || (x * x + y * y > 100)) {
					break;
				}
				
				//distance = sqrt( pow(x, 2) + pow(y, 2) );				
				
			}
			
			
			//NSLog(@"distance = %.2f", distance);
			
			int pos = j * [_imageRep pixelsWide] + k;
			
			// yellow
			if((abs(x) < 10) && (abs(y) < 10)) {
				pixels[3*pos+0] = 255; pixels[3*pos+1] = 255; pixels[3*pos+2] = 100;
			}
			
			if((abs(x) >= 10) && (abs(y) < 10)) {
				pixels[3*pos+0] = 90; pixels[3*pos+1] = 100; pixels[3*pos+2] = 200;
			}
			
			if((abs(x) < 10) && (abs(y) >= 10)) {
				pixels[3*pos+0] = 90; pixels[3*pos+1] = 70; pixels[3*pos+2] = 125;
			}
			
			if((abs(x) >= 10) && (abs(y) >= 10)) {
				pixels[3*pos+0] = 30; pixels[3*pos+1] = 50; pixels[3*pos+2] = 70;
			}
			
			
		}
	}
		
	
}

- (void) animateImage {

	[self generateImageRep];
	[_bioView setImage: _image];
	[_bioView setNeedsDisplay: YES];

}

- (void) awakeFromNib {

	_pixelsWide = 1000;
	_pixelsHigh = 600;
	
	_animZ = 0;

	_imageRep = [[NSBitmapImageRep alloc] initWithBitmapDataPlanes:NULL
														pixelsWide:_pixelsWide
														pixelsHigh:_pixelsHigh
													 bitsPerSample:8
												   samplesPerPixel:3
														  hasAlpha:NO
														  isPlanar:NO
													colorSpaceName:NSDeviceRGBColorSpace
													   bytesPerRow:_pixelsWide * 3
													  bitsPerPixel:24];

	NSSize imageSize = NSMakeSize(_pixelsWide, _pixelsHigh);

	[_imageRep setSize:imageSize];
	
	_image = [[NSImage alloc] initWithSize:imageSize];
	
	[_image addRepresentation:_imageRep];
	
	[self clearImageRep];
	
	[self animateImage];
	
	NSTimer *timer;

/*	timer = [NSTimer scheduledTimerWithTimeInterval: 0.09
                 target: self
                 selector: @selector(animateImage)
                 userInfo: nil
                 repeats: YES];*/
				 


	
		
}

@end
